/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
import{LitElement as d,css as k,nothing as b,html as l}from"lit";import{property as p,customElement as v}from"lit/decorators.js";import{styleMap as h}from"lit/directives/style-map.js";import{classMap as u}from"lit/directives/class-map.js";var n=function(i,t,r,e){var o=arguments.length,a=o<3?t:e===null?e=Object.getOwnPropertyDescriptor(t,r):e,c;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")a=Reflect.decorate(i,t,r,e);else for(var g=i.length-1;g>=0;g--)(c=i[g])&&(a=(o<3?c(a):o>3?c(t,r,a):c(t,r))||a);return o>3&&a&&Object.defineProperty(t,r,a),a};let s=class extends d{constructor(){super(...arguments),this.stages=[],this.activeStage=0}static{this.styles=k`:host{--progress-tracker-stage:0;--progress-tracker-stages:0;--progress-tracker-bar-height:4px;--progress-tracker-bar-border-radius:var(--progress-tracker-bar-height);--progress-tracker-bar-progress-bg-color:var(--typo3-state-primary-border-color);--progress-tracker-bar-track-bg-color:light-dark(var(--token-color-neutral-20),var(--token-color-neutral-80));--progress-tracker-indicator-size:12px;--progress-tracker-indicator-inlet-bg-default:transparent;--progress-tracker-indicator-inlet-bg-current:var(--typo3-state-primary-color);--progress-tracker-indicator-inlet-bg:var(--progress-tracker-indicator-inlet-bg-default);--progress-tracker-indicator-bg-default:light-dark(var(--token-color-neutral-20),var(--token-color-neutral-70));--progress-tracker-indicator-bg-complete:var(--typo3-state-primary-border-color);--progress-tracker-indicator-bg:var(--progress-tracker-indicator-bg-default);display:block;width:100%}.track-wrapper{position:relative;display:flex;flex-direction:column;align-items:center;min-height:var(--progress-tracker-indicator-size)}.track-bar-wrapper{position:absolute;top:calc((var(--progress-tracker-indicator-size) - var(--progress-tracker-bar-height))/2);width:100%;height:var(--progress-tracker-bar-height)}.track-bar{position:absolute;height:100%;inset-inline-start:calc(100%/var(--progress-tracker-stages)/2);border-radius:var(--progress-tracker-bar-border-radius)}.track-bar-track{width:calc(100%/var(--progress-tracker-stages)*(var(--progress-tracker-stages) - 1));background-color:var(--progress-tracker-bar-track-bg-color)}.track-bar-active{width:calc(100%/var(--progress-tracker-stages)*(var(--progress-tracker-stage) - 1));background-color:var(--progress-tracker-bar-progress-bg-color)}.stages{display:grid;grid-template-columns:repeat(var(--progress-tracker-stages),1fr);list-style:none;padding:0;margin:0;width:100%;position:relative}.stage{display:flex;flex-direction:column;align-items:center}.stage-indicator{position:relative;display:block;width:var(--progress-tracker-indicator-size);height:var(--progress-tracker-indicator-size);background-color:var(--progress-tracker-indicator-bg);border-radius:100%}.stage-indicator:after{content:"";position:absolute;top:50%;left:50%;width:calc(100% - 6px);height:calc(100% - 6px);border-radius:100%;transform:translate(-50%,-50%);background-color:var(--progress-tracker-indicator-inlet-bg)}.stage-indicator-complete,.stage-indicator-current{--progress-tracker-indicator-bg:var(--progress-tracker-indicator-bg-complete)}.stage-indicator-current:after{--progress-tracker-indicator-inlet-bg:var(--progress-tracker-indicator-inlet-bg-current)}.stage-label{margin-top:.5rem;text-align:center}@media (prefers-reduced-motion:no-preference){.track-bar-active{transition:width .5s ease-in-out}.stage-indicator,.stage-indicator:after{transition:background-color .5s ease-in-out}}`}render(){if(this.stages.length<2)return b;this.activeStage=Math.min(Math.max(this.activeStage,this.stages.length>0?1:0),this.stages.length);const t=h({"--progress-tracker-stage":`${this.activeStage}`,"--progress-tracker-stages":`${this.stages.length}`});return l`<div class=track-wrapper role=group style=${t}><div class=track-bar-wrapper><div class="track-bar track-bar-track"></div><div class="track-bar track-bar-active"></div></div><ul class=stages>${this.stages.map((r,e)=>this.renderStage(r,e+1))}</ul></div>`}renderStage(t,r){const e=u({"stage-indicator":!0,"stage-indicator-complete":r<this.activeStage,"stage-indicator-current":r===this.activeStage});return l`<li class=stage aria-current=${r===this.activeStage?"step":"false"}><span class=${e}></span> <span class=stage-label>${t}</span></li>`}};n([p({attribute:"stages",type:Array})],s.prototype,"stages",void 0),n([p({attribute:"active",type:Number,reflect:!0})],s.prototype,"activeStage",void 0),s=n([v("typo3-backend-progress-tracker")],s);export{s as ProgressTrackerElement};
